polybori::VariableFactory Class Reference

This base class VariableFactory is used for currying variable constructors with a BoolePolyRing. More...

`#include <VariableFactory.h>`

Inheritance diagram for polybori::VariableFactory:

## Public Types

typedef base::parent_type | parent_type
| Type of parent. More...
typedef BooleVariable | value_type
| We construct element of this type. More...
Public Types inherited from polybori::CFactoryBase
typedef BoolePolyRing | parent_type
| Type of parent. More...

## Public Member Functions

| VariableFactory (const parent_type &ring)
| Construct from given ring. More...
| VariableFactory (const self &rhs)
| Copy constructor. More...
| ~VariableFactory ()
| Destructor. More...
value_type | operator() () const
| Get first variable of the ring. More...
value_type | operator() (const value_type &rhs) const
| Indirect copy constructor. More...
value_type | operator() (const value_type::ring_type &ring) const
| Get first variable of explicit ring. More...
value_type | operator() (value_type::idx_type idx, const value_type::ring_type &ring) const
| Construct i-th variable for explit ring. More...
value_type | operator() (value_type::idx_type idx) const
| Construct i-th variable. More...
Public Member Functions inherited from polybori::CFactoryBase
| CFactoryBase (const parent_type &parent)
| Default constructor. More...
| CFactoryBase (const self &rhs)
| Copy constructor. More...
| ~CFactoryBase ()
| Destructor. More...
const parent_type & | parent () const
| Access delayed data. More...

## Detailed Description

This base class VariableFactory is used for currying variable constructors with a BoolePolyRing.

## Member Typedef Documentation

typedef base::parent_type polybori::VariableFactory::parent_type

Type of parent.

typedef BooleVariable polybori::VariableFactory::value_type

We construct element of this type.

## Constructor & Destructor Documentation

polybori::VariableFactory::VariableFactory | ( | const parent_type & | ring) |  |

inline

Construct from given ring.

polybori::VariableFactory::VariableFactory | ( | const self & | rhs) |  |

inline

Copy constructor.

polybori::VariableFactory::~VariableFactory | ( | ) |  |

inline

Destructor.

## Member Function Documentation

value_type polybori::VariableFactory::operator() | ( | ) |  | const

inline

Get first variable of the ring.

value_type polybori::VariableFactory::operator() | ( | const value_type & | rhs) |  | const

inline

Indirect copy constructor.

value_type polybori::VariableFactory::operator() | ( | const value_type::ring_type & | ring) |  | const

inline

Get first variable of explicit ring.

value_type polybori::VariableFactory::operator() | ( | value_type::idx_type | idx,
|  | const value_type::ring_type & | ring
| ) |  | const

inline

Construct i-th variable for explit ring.

value_type polybori::VariableFactory::operator() | ( | value_type::idx_type | idx) |  | const

inline

Construct i-th variable.

The documentation for this class was generated from the following file:

- VariableFactory.h